﻿-----####HPetBattleAny.lua 3.0####
----1.1:修改HPetBattleAny.ShowMaxValue函数的方式
----1.11:优化HPetBattleAny.CreateLinkByInfo,让生成的链接更合理(无ID宠物链接petID设为0，链接将可以发送到任意频道)
----1.12:god开关增加了娱乐效果
----1.2:修改HPetBattleAny.ShowMaxValue函数,直接生成string，根据设置，生成不同结果.
----1.21:去掉了"+"号.修正了娱乐模式中数值的正确性####
----1.3:修改HPetBattleAny.ShowMaxValue函数,让它调用HPetDate函数
----1.31:god模式下，战斗中/reload将会报错
----1.4:修复ShowMaxValue调用HPetDate出现的错误，重做god模式生成的链接（更符合实际情况）
----1.41:优化了一下成长值/品值输出方法。更下容易修改颜色。
----1.45:修复HPetBattleAny.ShowMaxValue中必须开启breed或品值的BUG。修复HPetBattleAny.CreateLinkByInfo给出的特殊链接无法发送BUG
----1.5:修改数据传递的方法
----1.6:换一个记录宠物数量的方式(避免在某些人宠物数量异常时会照成各种不知名的错误)
----1.61:修复一个很大的失误，成长值显示全部多了一个级别。
----1.65:loaduserpetinfo模块修复
----1.66:什么。？
----1.7:HPetBattleAny.EnemyPetInfo增加该次战斗是否拥有蓝色宠物
----1.71:加20%生命的条件改为C_PetBattles.IsWildBattle()
----1.72:创建宠物链接更加合理(误差依旧)
----1.73:对无法捕捉的宠物进行另一个提示
----1.74:尝试给那些不能被收集的宠物链接显示名字.(未测试)
----2.0:petID 不能为0必须为"0x0000000000000000"
----2.1:读取宠物数据加入了1.5秒的冷却(?),避免因为特殊情况无限读取照成登陆卡住
----2.2:HPetBattleAny:VARIABLES_LOADED解决每次新增设置模块都有错误的问题
----2.3:修复Steptime=GetTime()的位置错误
----2.4:加入PVP进战斗提示声
----2.41:pvp声音弄错
----2.5:设置界面整合进暴雪插件
----2.6:增加BreedIDStyle
----3.0:修改了插件的加载模式.现在不会直接加载PetJournal,也不会在进入游戏期间加载数据.(避免照成登陆游戏时卡一会儿的情况.)
----3.1:修改load部分,解决某些情况PetJournal会提前加载的问题(hook PetJournal:Show,进行加载内容.)

--- Globals
local _
local _G = getfenv(0)
local hooksecurefunc, tinsert, pairs, wipe = _G.hooksecurefunc, _G.table.insert, _G.pairs, _G.wipe
local ipairs = _G.ipairs
local C_PetJournal = _G.C_PetJournal
--- --------
local VERSION = GetAddOnMetadata("HPetBattleAny","Version")
local H_PET_BATTLE_CHAT_FRAME={}
local LEVEL_COLLECTED = "(%s)"--"(lv:%s)"
local L = HPetLocals


HPetBattleAny = CreateFrame("frame");
HPetBattleAny:SetScript('OnEvent', function(_, event, ...) return HPetBattleAny[event](HPetBattleAny, event, ...) end)
HPetBattleAny:Hide()

function HPetBattleAny:Init_HPET()
	if not self.initialized_HPET then
		self:RegisterEvent("VARIABLES_LOADED");
		self.initialized_HPET = true
		printt("test:插件载入")

		self:Loadinginfo()
		self:LoadSomeAny()
		if self.hook then self.hook:init() end
		self:RegisterEvent("PLAYER_ENTERING_WORLD")
		if PetJournal then
			HPetBattleAny:Init_BPET()
		end
	end
end
function HPetBattleAny:Init_BPET()
	if not self.initialized_BPET then
		self.initialized_BPET = true
		self:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
		self:initforJournalFrame()
		if self.hook_PJ then self.hook_PJ:init() end
	end
end
function HPetBattleAny:LoadSomeAny()
	if GetLocale()=="zhCN" then
		PET_BATTLE_COMBAT_LOG_AURA_APPLIED ="%1$s对%3$s %4$s 造成了%2$s效果."
		PET_BATTLE_COMBAT_LOG_PAD_AURA_APPLIED = "%1$s对%3$s 造成了%2$s效果."
		PET_BATTLE_COMBAT_LOG_MISS = "%s|cffff0000未命中|r%s %s。"
		PET_BATTLE_COMBAT_LOG_DODGE = "%s被%s %s|cffff0000躲闪|r了。";
	end
end
--------用于自动隐藏和显示的界面名字
HPetBattleAny.AutoHideShowfrmae={
	["MinimapCluster"]="",
	["Recount_MainWindow"]="",
}

function HPetBattleAny:PlaySoundFile(t)
------- 这里可以修改声音文件
	if t=="pvp" then
--~ 		PlaySound("igPlayerInvite", "Master");	----PVP提示声
		return
	end
	PlaySoundFile( [[Sound\Events\scourge_horn.wav]], "Master" );
end
function HPetBattleAny:Loadinginfo()
	self:PetPrintEX(format("HPetBattleAny"..VERSION..L["Loading"],"|cffff0000/hpq|r"))
end
--------------------		SAVE
HPetSaves={}
HPetBattleAny.Default={
	ShowMsg = true,				--在聊天窗口显示信息
	Sound=true,
	ShowGrowInfo=true,			--显示成长值
	PetGreedInfo=false,			--显示品值
	PetBreedInfo=false,			--breeID
	ShowBreedID=false,			--显示breedID
	EnemyAbility=true,			--显示敌对技能
	EnemyAbPoint={},			--位置(nil)
	EnemyAbScale=0.8,			--敌对技能大小
	OnlyInPetInfo=false,
	HighGlow=true,				--战斗中用品质颜色对宠物头像着色
	Tooltip=true,				--额外鼠标提示
	AutoSaveAbility=true,		--自动保存技能
	BreedIDStyle=true,
	ShowBandageButton=false,
}

--------------------		载入宠物手册的数据
HPetBattleAny.HasPet={}
--[[		function	]]--
-----	测试函数
function printt(...)
	if HPetSaves.god then
		print(...)
	end
end

function HPetBattleAny.sortRarityLevelAsc(a, b)
	if a.rarity == b.rarity then
		return a.level < b.level
	else
		return a.rarity < b.rarity
	end
end
-----	却确定宠物信息窗口
function HPetBattleAny:GetPetBattleChatFrmae()
	wipe(H_PET_BATTLE_CHAT_FRAME)
	H_PET_BATTLE_CHAT_FRAME={}
	if HPetSaves.OnlyInPetInfo then
		for _, chatFrameName in pairs(CHAT_FRAMES) do
			local frame = _G[chatFrameName];
			for index = #frame.messageTypeList,1,-1 do
				if frame.messageTypeList[index] == "PET_BATTLE_COMBAT_LOG" then
					table.insert(H_PET_BATTLE_CHAT_FRAME,frame)
					break
				end
			end
		end
	end
	if #H_PET_BATTLE_CHAT_FRAME==0 then
		table.insert(H_PET_BATTLE_CHAT_FRAME,DEFAULT_CHAT_FRAME)
	end
end
-----	打印函数
function HPetBattleAny:PetPrintEX(str,...)
	HPetBattleAny:GetPetBattleChatFrmae()

	for _,frame in pairs(H_PET_BATTLE_CHAT_FRAME) do
		if not frame:IsShown() then FCF_StartAlertFlash(frame) end
		frame:AddMessage(str,...)
	end

end
-----	创建宠物链接
function HPetBattleAny.CreateLinkByInfo(petID,petstate,usecustom)
	if petID == 0 or petID == "0x0000000000000000" or not petID then return nil end
	local name,speciesID,customName
	if not petstate then
		petstate={}
		speciesID, customName, petstate.level = C_PetJournal.GetPetInfoByPetID(petID)
		_, petstate.health, petstate.power, petstate.speed, petstate.rarity = C_PetJournal.GetPetStats(petID)
		if not speciesID then return end
		if not usecustom then customName = nil end
	else	--没有唯一ID说明petID就是唯一ID
		speciesID,petID = petID,"0x0000000000000000"
	end

	name = petstate.name or customName or C_PetJournal.GetPetInfoBySpeciesID(speciesID)
	if name then
		local level,health,power,speed,rarity = petstate.level, petstate.health, petstate.power, petstate.speed, petstate.rarity
		if HPetSaves.lie then
			HPetSaves.lie = tonumber(HPetSaves.lie) or 1
			rarity=rarity+HPetSaves.lie
		end
		local bhealth,bpower,bspeed,breedID = HPetDate.GetBreedValue(petstate,speciesID,true)
		health=format("%0.f",bhealth*tonumber("1."..(rarity-1))*level*5+100)
		power=format("%0.f",bpower*tonumber("1."..(rarity-1))*level)
		speed=format("%0.f",bspeed*tonumber("1."..(rarity-1))*level)
		local link=""
		rarity = rarity - 1
		link=ITEM_QUALITY_COLORS[rarity].hex.."\124Hbattlepet:"
		link=link..speciesID..":"..level..":"..rarity..":"..health..":"..power..":"..speed..":"..petID
		link=link.."\124h["..(customName or name).."]\124h\124r"
		return link
	end
	return
end
-----	成长值
function HPetBattleAny.ShowMaxValue(petstate,speciesID,point)
	local rarity
	if type(petstate) == "table" then
		rarity = petstate.rarity
	else
		rarity = select(5,C_PetJournal.GetPetStats(petstate)) or nil
	end
	if not rarity or rarity<1 then return end

	local breed = tonumber("1."..((rarity and rarity-1) or 0))
	local bhealth,bpower,bspeed,breedID,thealth,tpower,tspeed = HPetDate.GetBreedValue(petstate,speciesID)

	-- ghealth,gpower,gspeed	------成长值
	-- thealth,tpower,tspeed	------基础值
	-- bhealth,bpower,bspeed	------breed加值
	local ghealth=format("%.1f",(bhealth+thealth)*5*breed)
	local gpower=format("%.1f",(bpower+tpower)*breed)
	local gspeed=format("%.1f",(bspeed+tspeed)*breed)

	-- 输出值
	local rhealth,rpower,rspeed
	rhealth=""
	rpower=""
	rspeed=""

	if point then
		if HPetSaves.PetBreedInfo then
			rhealth = bhealth
			rpower = bpower
			rspeed = bspeed
		elseif HPetSaves.PetGreedInfo then
			rhealth = bhealth+thealth
			rpower = bpower+tpower
			rspeed = bspeed+tspeed
		else
			rhealth = ghealth
			rpower = gpower
			rspeed = gspeed
		end
	else
		local hpsGetInfo=function()
			if HPetSaves.PetGreedInfo and HPetSaves.PetBreedInfo then
				local ty="+"
				return thealth..ty..bhealth,tpower..ty..bpower,tspeed..ty..bspeed
			elseif HPetSaves.PetBreedInfo then
				return bhealth,bpower,bspeed
			elseif HPetSaves.PetGreedInfo then
				return thealth+bhealth,tpower+bpower,tspeed+bspeed
			end
		end
		local stlye1="(|c"..RAID_CLASS_COLORS["ROGUE"].colorStr.."%s|r)"
		local stlye2="(|c"..RAID_CLASS_COLORS["MAGE"].colorStr.."%s|r)"

		if HPetSaves.PetGreedInfo or HPetSaves.PetBreedInfo  then
			rhealth,rpower,rspeed = hpsGetInfo()
			rhealth = format(stlye2,rhealth)
			rpower 	= format(stlye2,rpower)
			rspeed 	= format(stlye2,rspeed)
		end
		if HPetSaves.ShowGrowInfo then
			rhealth = format(stlye1,ghealth)..rhealth
			rpower = format(stlye1,gpower)..rpower
			rspeed = format(stlye1,gspeed)..rspeed
		end

	end
	return rhealth,rpower,rspeed,breedID
end

-----	调出宠物收集信息(已有宠物信息)
function HPetBattleAny:GetPetCollectedInfo(speciesID,enemypet,islink,mini)
	local str1=""
	local str2=""
	local pets=type(speciesID)=="table" and  speciesID or HPetBattleAny:GetPetInfo(speciesID)
	if enemypet and enemypet.level then
		if enemypet.level>20 then
			enemypet.level = enemypet.level-2
		elseif enemypet.level>15 then
			enemypet.level = enemypet.level-1
		end
	end
	if pets then
		table.sort(pets,self.sortRarityLevelAsc)
		if enemypet and self.sortRarityLevelAsc(pets[1],enemypet) then
			str1 = str1.."|cffff0000"..L["Only collected"]	.."：|r"
		else
			str1 = str1.."|cffffff00"..COLLECTED.."：|r"
		end
		for i,petInfo in pairs(pets) do
			local petlink
			local _,custname,_,_,_,_,_,name=C_PetJournal.GetPetInfoByPetID(petInfo.petID)

			if islink then
				petlink=HPetBattleAny.CreateLinkByInfo(petInfo.petID or 0,nil,true)
			end

			if not petlink then
				if (custname or name) and not mini then
					petlink=ITEM_QUALITY_COLORS[petInfo.rarity-1].hex..(custname or name).."|r"
				else
					petlink=ITEM_QUALITY_COLORS[petInfo.rarity-1].hex.._G["BATTLE_PET_BREED_QUALITY"..petInfo.rarity].."|r"

				end
			end


			if petlink then
				local breedID = select(4,HPetDate.GetBreedValue(petInfo.petID))
				if (breedID and ((breedID>=4 and breedID<=6) or (breedID>=14 and breedID<=16))) then
					petlink=petlink..ICON_LIST[ICON_TAG_LIST[strlower(RAID_TARGET_1)]] .. "0|t"
				end
				if LEVEL_COLLECTED then petlink = format(LEVEL_COLLECTED.."%s",petInfo.level,petlink) end
				if islink or str2=="" then
					str2 = petlink..str2
				else
					str2=petlink.."|n"..str2
				end
			end
		end
	else
		if (C_PetBattles.IsPlayerNPC(2) and select(2,C_PetBattles.IsTrapAvailable())>6 and select(2,C_PetBattles.IsTrapAvailable())<9) or select(2,C_PetBattles.IsTrapAvailable())==6 then
			str1=str1.."|cffffff00".._G["PET_BATTLE_TRAP_ERR_"..select(2,C_PetBattles.IsTrapAvailable())]
		else
			if enemypet and not select(7,C_PetJournal.GetPetInfoBySpeciesID(speciesID)) then
				str1=str1.."|cffffff00".._G["PET_BATTLE_TRAP_ERR_6"]
			else
				str1=str1.."|cffff0000"..NOT_COLLECTED.."!|r"
			end
		end
	end
	return str1,str2
end


--[[ 	OnEvent:					PET_BATTLE_OPENING_START	]]--
function HPetBattleAny:PET_BATTLE_OPENING_START(...)
printt("test:战斗开始"..GetTime())
--~ self:PetPrintEX("---战斗开始---",1,0.96,0.41)
self.EnemyPetInfo={}
----- 输出敌对宠物的数据
		local petOwner=2
		for petIndex=1, C_PetBattles.GetNumPets(petOwner) do
			local speciesID=C_PetBattles.GetPetSpeciesID(petOwner,petIndex)
			local pets=HPetBattleAny:GetPetInfo(speciesID)
			if not ((C_PetBattles.IsPlayerNPC(2)and(select(2,C_PetBattles.IsTrapAvailable())==7)) or pets or ... == "lock") then HPetBattleAny:RunLagFunc("HPetBattleAny:PET_BATTLE_OPENING_START('lock')",2);printt("test:延迟调用"..GetTime());return end
			local name = C_PetBattles.GetName(petOwner, petIndex);
			local level = C_PetBattles.GetLevel(petOwner, petIndex);
			local health = C_PetBattles.GetMaxHealth(petOwner, petIndex);if C_PetBattles.IsWildBattle() then health =format("%.0f",health * 1.2) end	--生命加20%
			local power = C_PetBattles.GetPower(petOwner, petIndex);
			local speed = C_PetBattles.GetSpeed(petOwner, petIndex);
			local rarity=C_PetBattles.GetBreedQuality(petOwner,petIndex);if rarity>3 and rarity~=6 and C_PetBattles.IsWildBattle() then self.EnemyPetInfo.FindBlue=true end;
			local isflying = false
			if C_PetBattles.GetAuraInfo(petOwner,petIndex,1) == 239 then
				speed=format("%.0f",speed/1.5) --速度降50%
				isflying = true
			end

			self.EnemyPetInfo[petIndex]={["name"]=name,["level"]=level,["health"]=health,["power"]=power,["speed"]=speed,["breedID"]=nil,["rarity"]=rarity,["isflying"]=isflying}

			local breedID=select(4,HPetDate.GetBreedValue(self.EnemyPetInfo[petIndex],speciesID))	--获取breedID

			self.EnemyPetInfo[petIndex].breedID=breedID

			tmprint=format(L["this is"],petIndex)

			if (breedID and ((breedID>=4 and breedID<=6) or (breedID>=14 and breedID<=16))) then
				tmprint=tmprint..ICON_LIST[ICON_TAG_LIST[strlower(RAID_TARGET_1)]] .. "0|t"
			end

			tmprint=tmprint..HPetBattleAny.CreateLinkByInfo(speciesID,self.EnemyPetInfo[petIndex])

			if LEVEL_COLLECTED then tmprint=format("%s"..LEVEL_COLLECTED,tmprint,level) end

			if HPetSaves.Contrast or true then
				local str1,str2 = HPetBattleAny:GetPetCollectedInfo(speciesID,{["level"]=level,["rarity"]=rarity},true)
				tmprint = tmprint..str1..str2
			end

			if HPetSaves.ShowMsg then
				self:PetPrintEX(tmprint)
			end
		end

		if HPetSaves.Sound and self.EnemyPetInfo.FindBlue then --C_PetBattles.IsPlayerNPC(2) and select(2,C_PetBattles.IsTrapAvailable())~=7 then
--- 		PlaySoundFile( [[Sound\Event Sounds\Event_wardrum_ogre.wav]], "Master" );
			self:PlaySoundFile()
		end
	return true
end


--[[	OnEvent:					PET_JOURNAL_LIST_UPDATE		]]--
local Steptime=0
function HPetBattleAny:PET_JOURNAL_LIST_UPDATE(fast)
	if not self:IsEventRegistered("PET_JOURNAL_LIST_UPDATE") then
		self:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
	end
	if (HPetSaves.Contrast or true ) and not self.HasPetloading and (fast or GetTime() - 1.5 > Steptime) then
		local total, owned = C_PetJournal.GetNumPets(false);
		if not HPetBattleAny.HasPet.owned or owned ~=  HPetBattleAny.HasPet.owned or (not fast and total > HPetBattleAny.HasPet.total) then
			Steptime=GetTime()
			printt("|cffff0000系统数据:"..owned.."插件数据"..(self.HasPet.owned or 0).."|r")---..(total or "nil").."|"..(HPetBattleAny.HasPet.total or "nil"))
			self:LoadUserPetInfo()
		end
	end
end
local ErrorisShow = true
function HPetBattleAny:LoadUserPetInfo()
	printt("test:数据处理.进入判断")
	if HPetBattleAny.HasPetloading then
		return	false
	end
	HPetBattleAny.HasPetloading = true
	local owned = select(2,C_PetJournal.GetNumPets(true))
	printt("test:数据处理.开始"..owned)
	wipe(HPetBattleAny.HasPet)
	C_PetJournal.ClearSearchFilter();
	C_PetJournal.AddAllPetTypesFilter();
	C_PetJournal.AddAllPetSourcesFilter();
	C_PetJournal.SetFlagFilter(LE_PET_JOURNAL_FLAG_COLLECTED, true)
	C_PetJournal.SetFlagFilter(LE_PET_JOURNAL_FLAG_FAVORITES, false)
	HPetBattleAny.HasPet.total ,HPetBattleAny.HasPet.owned = C_PetJournal.GetNumPets(false)
	for i=1,owned do
		local petID, speciesID, isOwned, _,level= C_PetJournal.GetPetInfoByIndex(i);
		if isOwned then
			if not HPetBattleAny.HasPet[speciesID] then HPetBattleAny.HasPet[speciesID]={} end
			table.insert(HPetBattleAny.HasPet[speciesID],petID)
		end
	end

	HPetBattleAny.HasPetloading = false
--~ 	if self.HasPet.owned~=select(2,C_PetJournal.GetNumPets(true)) or owned==0 and ErrorisShow then
--~ 		print("出现异常,因为客户端不完整/宠物缓存不完整的缘故.可能出现'顿卡'情况")
--~ 		ErrorisShow=false
--~ 	end
	printt("test:数据处理.结束,载入数据"..HPetBattleAny.HasPet.owned)
end
function HPetBattleAny:GetPetInfo(speciesID)
	if not HPetBattleAny.HasPet.total then
		HPetBattleAny:PET_JOURNAL_LIST_UPDATE(true)
	end
	if HPetBattleAny.HasPet[speciesID] then
		local pets={}
		for _,petID in pairs(HPetBattleAny.HasPet[speciesID]) do
			local _,_,_,_,rarity = C_PetJournal.GetPetStats(petID)
			local _,_,level = C_PetJournal.GetPetInfoByPetID(petID)
			if not rarity or not level then return end
			tinsert(pets,{petID=petID,rarity=rarity,level=level})
		end
		return pets
	end
end
---延迟运行特定的func
local lag_timer = 0
function HPetBattleAny:RunLagFunc(func,timer)
	HPetBattleAny["LagFunc"]=func
	lag_timer = -timer
	HPetBattleAny:Show()
end
local lag_running = false
HPetBattleAny:SetScript("OnUpdate", function(frame, elapsed)
    lag_timer = lag_timer + elapsed
	if lag_timer > 0 then
		if lag_running then return end
		lag_running = true
		HPetBattleAny:Hide()
		local func = HPetBattleAny["LagFunc"]
		HPetBattleAny["LagFunc"]=nil
		if type(func) == "function" then
			func()
		elseif type(func) == "string" then
			pcall(loadstring(func))
		end
		lag_running = false
		lag_timer = 0
	end
end)
--[[	OnEvent:	 				ADDON_LOADED			]]--
function HPetBattleAny:ADDON_LOADED(_, name)
	if name == "HPetBattleAny" then
		HPetBattleAny:Init_HPET()
	elseif name=="Blizzard_PetJournal" then
		HPetBattleAny:Init_BPET()
	end
	if self.initialized_BPET and self.initialized_HPET then
		self:UnregisterEvent("ADDON_LOADED")
	end
end
function HPetBattleAny:PLAYER_ENTERING_WORLD()
	self:RegisterEvent("PET_BATTLE_OPENING_START")
end
function HPetBattleAny:VARIABLES_LOADED()
	for v,t in pairs(self.Default) do
		if HPetSaves[v]==nil or type(HPetSaves[v])~=type(t) then
			printt(v,t)
			HPetSaves[v] = t
		end
	end
	if not HPetSaves.PetAblitys then HPetSaves.PetAblitys={} end
end
------------------------我是和谐的分割线---------------------------------


function HPetBattleAny:initforJournalFrame()
	local button
	button = CreateFrame("Button","HPetInitOpenButton",PetJournal,"UIPanelButtonTemplate")
	button:SetText(L["HPet Options"])
	button:SetHeight(22)
	button:SetWidth(#L["HPet Options"]*8)
	button:SetPoint("TOPLEFT", PetJournalPetCard, "BOTTOMLEFT", -5, 0)
	button:SetScript("OnClick",function()
		if HPetOption then
			HPetOption:Toggle()
		end
	end)

	button = CreateFrame("Button","HPetAllInfoButton",PetJournal,"UIMenuButtonStretchTemplate")
	button:SetText(L["Pet All Info"])
	button:SetHeight(20)
	button:SetWidth(100)
	button:SetPoint("TOPRIGHT", PetJournalPetCard, "BOTTOMRIGHT", -5, 0)
	button.rightArrow:Show()
	button:SetScript("OnClick",function()
		if HPetAllInfoFrame then
			HPetAllInfoFrame:Toggle()
		end
	end)

 	PetJournalPetCardModelFrame:SetPoint("TOPLEFT",PetJournalPetCard,75,-21)--65
 	PetJournalPetCardShadows:SetPoint("TOPLEFT",PetJournalPetCard,55,-67)--45

	if self.initSwathButton then self.initSwathButton() end
end
function HPetBattleAny:PET_BATTLE_QUEUE_PROPOSE_MATCH()
	HPetBattleAny:PlaySoundFile("pvp")
end
HPetBattleAny:RegisterEvent("ADDON_LOADED")
HPetBattleAny:RegisterEvent("PET_BATTLE_QUEUE_PROPOSE_MATCH")
